PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Attributes | List of all members
XMPP::Roster::Item Class Reference

`#include <xmpp_roster.h>`

Inheritance diagram for XMPP::Roster::Item:
[legend]
Collaboration diagram for XMPP::Roster::Item:
[legend]

## Public Member Functions
| Item (PXMLElement *item=0)
| Item (PXMLElement &item)
| Item (const JID &jid, ItemType type, const PString &group, const PString &name=PString::Empty())
const JID & | GetJID () const
ItemType | GetType () const
const PString & | GetName () const
const PStringSet & | GetGroups () const
const PresenceInfo & | GetPresence () const
virtual void | SetJID (const JID &jid, PBoolean dirty=true)
virtual void | SetType (ItemType type, PBoolean dirty=true)
virtual void | SetName (const PString &name, PBoolean dirty=true)
virtual void | AddGroup (const PString &group, PBoolean dirty=true)
virtual void | RemoveGroup (const PString &group, PBoolean dirty=true)
virtual void | SetPresence (const Presence &p)
void | SetDirty (PBoolean b=true)
Item & | operator= (const PXMLElement &item)
| This operator will set the dirty flag. More...
virtual PXMLElement * | AsXML (PXMLElement *parent) const
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
BareJID | m_JID
ItemType | m_Type
PString | m_Name
PStringSet | m_Groups
PDictionary< PString, Presence > | m_Presence
PBoolean | m_IsDirty
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Friends inherited from PObject

## Constructor & Destructor Documentation

XMPP::Roster::Item::Item | ( | PXMLElement * | item = `0` | ) |

XMPP::Roster::Item::Item | ( | PXMLElement & | item | ) |

XMPP::Roster::Item::Item | ( | const JID & | jid,
|  | ItemType | type,
|  | const PString & | group,
|  | const PString & | name = `PString::Empty()`
| ) |  |

## Member Function Documentation

virtual void XMPP::Roster::Item::AddGroup | ( | const PString & | group,
|  | PBoolean | dirty = `true`
| ) |  |
| virtual

virtual PXMLElement* XMPP::Roster::Item::AsXML | ( | PXMLElement * | parent | ) | const
| virtual

const PStringSet& XMPP::Roster::Item::GetGroups | ( |  | ) | const
| inline

References m_Groups.

const JID& XMPP::Roster::Item::GetJID | ( |  | ) | const
| inline

References m_JID.

const PString& XMPP::Roster::Item::GetName | ( |  | ) | const
| inline

References m_Name.

const PresenceInfo& XMPP::Roster::Item::GetPresence | ( |  | ) | const
| inline

References m_Presence.

ItemType XMPP::Roster::Item::GetType | ( |  | ) | const
| inline

References m_Type.

Item& XMPP::Roster::Item::operator= | ( | const PXMLElement & | item | ) |

This operator will set the dirty flag.

virtual void XMPP::Roster::Item::RemoveGroup | ( | const PString & | group,
|  | PBoolean | dirty = `true`
| ) |  |
| virtual

void XMPP::Roster::Item::SetDirty | ( | PBoolean | b = `true` | ) |
| inline

References m_IsDirty.

Referenced by SetJID(), SetName(), and SetType().

virtual void XMPP::Roster::Item::SetJID | ( | const JID & | jid,
|  | PBoolean | dirty = `true`
| ) |  |
| inline virtual

References m_JID, and SetDirty().

virtual void XMPP::Roster::Item::SetName | ( | const PString & | name,
|  | PBoolean | dirty = `true`
| ) |  |
| inline virtual

References m_Name, and SetDirty().

virtual void XMPP::Roster::Item::SetPresence | ( | const Presence & | p | ) |
| virtual

virtual void XMPP::Roster::Item::SetType | ( | ItemType | type,
|  | PBoolean | dirty = `true`
| ) |  |
| inline virtual

References m_Type, and SetDirty().

## Member Data Documentation

PStringSet XMPP::Roster::Item::m_Groups
| protected

Referenced by GetGroups().

PBoolean XMPP::Roster::Item::m_IsDirty
| protected

Referenced by SetDirty().

BareJID XMPP::Roster::Item::m_JID
| protected

Referenced by GetJID(), and SetJID().

PString XMPP::Roster::Item::m_Name
| protected

Referenced by GetName(), and SetName().

PDictionary<PString, Presence> XMPP::Roster::Item::m_Presence
| protected

Referenced by GetPresence().

ItemType XMPP::Roster::Item::m_Type
| protected

Referenced by GetType(), and SetType().

The documentation for this class was generated from the following file:

- xmpp_roster.h